Crypto++ 8.6 Free C++ class library of cryptographic schemes

Public Member Functions | List of all members
RWFunction Class Reference

Rabin-Williams trapdoor function using the public key. More...

Inheritance diagram for RWFunction:

## Public Member Functions
void | Initialize (const Integer &n)
| Initialize a Rabin-Williams public key. More...
void | BERDecode (BufferedTransformation &bt)
void | DEREncode (BufferedTransformation &bt) const
void | Save (BufferedTransformation &bt) const
| Saves a key to a BufferedTransformation. More...
void | Load (BufferedTransformation &bt)
| Loads a key from a BufferedTransformation. More...
Integer | ApplyFunction (const Integer &x) const
| Applies the trapdoor. More...
Integer | PreimageBound () const
| Returns the maximum size of a message before the trapdoor function is applied. More...
Integer | ImageBound () const
| Returns the maximum size of a representation after the trapdoor function is applied. More...
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object. More...
const Integer & | GetModulus () const
void | SetModulus (const Integer &n)
Public Member Functions inherited from TrapdoorFunction
Integer | ApplyRandomizedFunction (RandomNumberGenerator &rng, const Integer &x) const
| Applies the trapdoor function. More...
bool | IsRandomized () const
| Determines if the encryption algorithm is randomized. More...
Public Member Functions inherited from TrapdoorFunctionBounds
virtual Integer | MaxPreimage () const
| Returns the maximum size of a message before the trapdoor function is applied bound to a public key. More...
virtual Integer | MaxImage () const
| Returns the maximum size of a representation after the trapdoor function is applied bound to a public key. More...
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
virtual bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation. More...
virtual void | Precompute (unsigned int precomputationStorage)
| Perform precomputation. More...
virtual void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation. More...
virtual void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use. More...
void | DoQuickSanityCheck () const
| Perform a quick sanity check. More...
Public Member Functions inherited from NameValuePairs
template<class T >
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject. More...
template<class T >
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object. More...
template<class T >
bool | GetValue (const char *name, T &value) const
| Get a named value. More...
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value. More...
CRYPTOPP_DLL std::string | GetValueNames () const
| Get a list of value names that can be retrieved. More...
CRYPTOPP_DLL bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int. More...
CRYPTOPP_DLL int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default. More...
CRYPTOPP_DLL bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64. More...
CRYPTOPP_DLL word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default. More...
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair. More...
CRYPTOPP_DLL void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair. More...

## Additional Inherited Members
Static Public Member Functions inherited from NameValuePairs
static CRYPTOPP_DLL void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present. More...

## Detailed Description

Rabin-Williams trapdoor function using the public key.

Since
  Crypto++ 3.0, Tweaked roots using e and f since Crypto++ 5.6.4

Definition at line 23 of file rw.h.

## Member Function Documentation

## ◆ Initialize()

void RWFunction::Initialize | ( | const Integer & | n | ) |
| inline

Initialize a Rabin-Williams public key.

Parameters

  n | the modulus

Definition at line 31 of file rw.h.

## ◆ Save()

void RWFunction::Save | ( | BufferedTransformation & | bt | ) | const
| inline virtual

Saves a key to a BufferedTransformation.

Parameters

  bt | the destination BufferedTransformation

Exceptions

  NotImplemented |

Save() writes the material to a BufferedTransformation.

If the material is a key, then the key is written with ASN.1 DER encoding. The key includes an object identifier with an algorithm id, like a subjectPublicKeyInfo.

A "raw" key without the "key info" can be saved using a key's DEREncode() method.

If a derived class does not override Save(), then the base class throws NotImplemented().

Reimplemented from CryptoMaterial.

Reimplemented in InvertibleRWFunction.

Definition at line 37 of file rw.h.

## ◆ Load()

void RWFunction::Load | ( | BufferedTransformation & | bt | ) |
| inline virtual

Loads a key from a BufferedTransformation.

Parameters

  bt | the source BufferedTransformation

Exceptions

  KeyingErr |

Load() attempts to read material from a BufferedTransformation. If the material is a key that was generated outside the library, then the following usually applies:

- the key should be ASN.1 BER encoded
- the key should be a "key info"

"key info" means the key should have an object identifier with an algorithm id, like a subjectPublicKeyInfo.

To read a "raw" key without the "key info", then call the key's BERDecode() method.

Note
  Load() generally does not check that the key is valid. Call Validate(), if needed.

Reimplemented from CryptoMaterial.

Reimplemented in InvertibleRWFunction.

Definition at line 39 of file rw.h.

## ◆ ApplyFunction()

Integer RWFunction::ApplyFunction | ( | const Integer & | x | ) | const
| virtual

Applies the trapdoor.

Parameters

  x | the message on which the encryption function is applied

Returns
  the message x encrypted under the public key

ApplyFunction is a generalization of encryption under a public key cryptosystem. Derived classes must implement it.

Implements TrapdoorFunction.

## ◆ PreimageBound()

Integer RWFunction::PreimageBound | ( |  | ) | const
| inline virtual

Returns the maximum size of a message before the trapdoor function is applied.

Returns
  the maximum size of a message before the trapdoor function is applied

Derived classes must implement PreimageBound().

Implements TrapdoorFunctionBounds.

Definition at line 43 of file rw.h.

## ◆ ImageBound()

Integer RWFunction::ImageBound | ( |  | ) | const
| inline virtual

Returns the maximum size of a representation after the trapdoor function is applied.

Returns
  the maximum size of a representation after the trapdoor function is applied

Derived classes must implement ImageBound().

Implements TrapdoorFunctionBounds.

Definition at line 44 of file rw.h.

## ◆ Validate()

bool RWFunction::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) |  | const
| virtual

Check this object for errors.

Parameters

  rng | a RandomNumberGenerator for objects which use randomized testing
  level | the level of thoroughness

Returns
  true if the tests succeed, false otherwise

There are four levels of thoroughness:

- 0 - using this object won't cause a crash or exception
- 1 - this object will probably function, and encrypt, sign, other operations correctly
- 2 - ensure this object will function correctly, and perform reasonable security checks
- 3 - perform reasonable security checks, and do checks that may take a long time

Level 0 does not require a RandomNumberGenerator. A NullRNG() can be used for level 0. Level 1 may not check for weak keys and such. Levels 2 and 3 are recommended.

See also
  ThrowIfInvalid()

Implements CryptoMaterial.

Reimplemented in InvertibleRWFunction.

## ◆ GetVoidValue()

bool RWFunction::GetVoidValue | ( | const char * | name,
|  | const std::type_info & | valueType,
|  | void * | pValue
| ) |  | const
| virtual

Get a named value.

Parameters

  name | the name of the object or value to retrieve
  valueType | reference to a variable that receives the value
  pValue | void pointer to a variable that receives the value

Returns
  true if the value was retrieved, false otherwise

GetVoidValue() retrieves the value of name if it exists.

Note
  GetVoidValue() is an internal function and should be implemented by derived classes. Users should use one of the other functions instead.

See also
  GetValue(), GetValueWithDefault(), GetIntValue(), GetIntValueWithDefault(), GetRequiredParameter() and GetRequiredIntParameter()

Implements NameValuePairs.

Reimplemented in InvertibleRWFunction.

## ◆ AssignFrom()

void RWFunction::AssignFrom | ( | const NameValuePairs & | source | ) |
| virtual

Assign values to this object.

This function can be used to create a public key from a private key.

Implements CryptoMaterial.

Reimplemented in InvertibleRWFunction.

The documentation for this class was generated from the following file:

- rw.h